<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/ref.spl.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'es',
  ),
  'this' => 
  array (
    0 => 'function.spl-autoload-register.php',
    1 => 'spl_autoload_register',
  ),
  'up' => 
  array (
    0 => 'ref.spl.php',
    1 => 'Funciones SPL',
  ),
  'prev' => 
  array (
    0 => 'function.spl-autoload-functions.php',
    1 => 'spl_autoload_functions',
  ),
  'next' => 
  array (
    0 => 'function.spl-autoload-unregister.php',
    1 => 'spl_autoload_unregister',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'es',
    'path' => 'reference/spl/functions/spl-autoload-register.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="function.spl-autoload-register" class="refentry">
 <div class="refnamediv">
  <h1 class="refname">spl_autoload_register</h1>
  <p class="verinfo">(PHP 5 &gt;= 5.1.0, PHP 7, PHP 8)</p><p class="refpurpose"><span class="refname">spl_autoload_register</span> &mdash; <span class="dc-title">Registrar las funciones dadas como implementación de __autoload()</span></p>

 </div>
 <div class="refsect1 description" id="refsect1-function.spl-autoload-register-description">
  <h3 class="title">Descripción</h3>
  <div class="methodsynopsis dc-description">
   <span class="methodname"><strong>spl_autoload_register</strong></span>(<span class="methodparam"><span class="type"><a href="language.types.callable.php" class="type callable">callable</a></span> <code class="parameter">$autoload_function</code><span class="initializer"> = ?</span></span>, <span class="methodparam"><span class="type"><a href="language.types.boolean.php" class="type bool">bool</a></span> <code class="parameter">$throw</code><span class="initializer"> = <strong><code><a href="reserved.constants.php#constant.true">true</a></code></strong></span></span>, <span class="methodparam"><span class="type"><a href="language.types.boolean.php" class="type bool">bool</a></span> <code class="parameter">$prepend</code><span class="initializer"> = <strong><code><a href="reserved.constants.php#constant.false">false</a></code></strong></span></span>): <span class="type"><a href="language.types.boolean.php" class="type bool">bool</a></span></div>

  <p class="para rdfs-comment">
   Registra una función con la cola de __autoload proporcionada por spl. Si la cola
   aún no ha sido activa, será activada.
  </p>
  <p class="para">
   Si el código contiene una función <span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span> existente,
   dicha función debe estar explícitamente registrada en la cola de __autoload. Esto
   es debido a que <span class="function"><strong>spl_autoload_register()</strong></span> de hecho reemplazará
   la caché del motor para la función <span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span>
   mediante <span class="function"><a href="function.spl-autoload.php" class="function">spl_autoload()</a></span> o
   <span class="function"><a href="function.spl-autoload-call.php" class="function">spl_autoload_call()</a></span>.
  </p>
  <p class="para">
   Si deben haber varias funciones de autocarga, <span class="function"><strong>spl_autoload_register()</strong></span> 
   lo permite. De hecho, crea una cola de funciones de autocarga y
   las recorre en el orden en que fueron definidas. Por el contrario,
   <span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span> sólo puede definirse una vez.
  </p>
 </div>

 
 <div class="refsect1 parameters" id="refsect1-function.spl-autoload-register-parameters">
  <h3 class="title">Parámetros</h3>
  <p class="para">
   <dl>
    
     <dt><code class="parameter">autoload_function</code></dt>
     <dd>
      <p class="para">
       La función de autocarga a registrar.
       Si no se proporciona ningún parámetro, será registrada la implementación
       predeterminada de <span class="function"><a href="function.spl-autoload.php" class="function">spl_autoload()</a></span>.
      </p>
     </dd>
    
    
     <dt><code class="parameter">throw</code></dt>
     <dd>
      <p class="para">
       Este parámetro especifica si
       <span class="function"><strong>spl_autoload_register()</strong></span> debería lanzar
       excepciones cuando el parámetro <code class="parameter">autoload_function</code>
       no puede ser registrado.
      </p>
     </dd>
    
    
     <dt><code class="parameter">prepend</code></dt>
     <dd>
      <p class="para">
       Si es <strong><code><a href="reserved.constants.php#constant.true">true</a></code></strong>, <span class="function"><strong>spl_autoload_register()</strong></span> antepondrá
       el autocargador en la pila de autocarga en vez de posponerlo.
      </p>
     </dd>
    
   </dl>
  </p>
 </div>

 
 <div class="refsect1 returnvalues" id="refsect1-function.spl-autoload-register-returnvalues">
  <h3 class="title">Valores devueltos</h3>
  <p class="para">
   Devuelve <strong><code><a href="reserved.constants.php#constant.true">true</a></code></strong> en caso de éxito o <strong><code><a href="reserved.constants.php#constant.false">false</a></code></strong> en caso de error.
  </p>
 </div>

 
 <div class="refsect1 changelog" id="refsect1-function.spl-autoload-register-changelog">
  <h3 class="title">Historial de cambios</h3>
  <p class="para">
   <table class="doctable informaltable">
    
     <thead>
      <tr>
       <th>Versión</th>
       <th>Descripción</th>
      </tr>

     </thead>

     <tbody class="tbody">
      <tr>
       <td>5.3.0</td>
       <td>
        Se introdujo el soporte para espacios de nombres.
       </td>
      </tr>

      <tr>
       <td>5.3.0</td>
       <td>
        Se añadio el parámetro <code class="parameter">prepend</code>.
       </td>
      </tr>

     </tbody>
    
   </table>

  </p>
 </div>

 
 <div class="refsect1 examples" id="refsect1-function.spl-autoload-register-examples">
  <h3 class="title">Ejemplos</h3>
  <p class="para">
   <div class="example" id="">
    <p><strong>Ejemplo #1 <span class="function"><strong>spl_autoload_register()</strong></span> como sustituto de una función <span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span></strong></p>
    <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br /><br /></span><span style="color: #FF8000">// function __autoload($clase) {<br />//     include 'clases/' . $clase . '.clase.php';<br />// }<br /><br /></span><span style="color: #007700">function </span><span style="color: #0000BB">mi_autocargador</span><span style="color: #007700">(</span><span style="color: #0000BB">$clase</span><span style="color: #007700">) {<br />    include </span><span style="color: #DD0000">'clases/' </span><span style="color: #007700">. </span><span style="color: #0000BB">$clase </span><span style="color: #007700">. </span><span style="color: #DD0000">'.clase.php'</span><span style="color: #007700">;<br />}<br /><br /></span><span style="color: #0000BB">spl_autoload_register</span><span style="color: #007700">(</span><span style="color: #DD0000">'mi_autocargador'</span><span style="color: #007700">);<br /><br /></span><span style="color: #FF8000">// O, utilizar una función anónima, a partir de PHP 5.3.0<br /></span><span style="color: #0000BB">spl_autoload_register</span><span style="color: #007700">(function (</span><span style="color: #0000BB">$clase</span><span style="color: #007700">) {<br />    include </span><span style="color: #DD0000">'clases/' </span><span style="color: #007700">. </span><span style="color: #0000BB">$clase </span><span style="color: #007700">. </span><span style="color: #DD0000">'.clase.php'</span><span style="color: #007700">;<br />});<br /><br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
    </div>

   </div>
   <div class="example" id="">
    <p><strong>Ejemplo #2 Ejemplo de <span class="function"><strong>spl_autoload_register()</strong></span> donde la clase no es cargada</strong></p>
    <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br /><br /></span><span style="color: #007700">namespace </span><span style="color: #0000BB">Foobar</span><span style="color: #007700">;<br /><br />class </span><span style="color: #0000BB">Foo </span><span style="color: #007700">{<br />    static public function </span><span style="color: #0000BB">test</span><span style="color: #007700">(</span><span style="color: #0000BB">$nombre</span><span style="color: #007700">) {<br />        print </span><span style="color: #DD0000">'[['</span><span style="color: #007700">. </span><span style="color: #0000BB">$nombre </span><span style="color: #007700">.</span><span style="color: #DD0000">']]'</span><span style="color: #007700">;<br />    }<br />}<br /><br /></span><span style="color: #0000BB">spl_autoload_register</span><span style="color: #007700">(</span><span style="color: #0000BB">__NAMESPACE__ </span><span style="color: #007700">.</span><span style="color: #DD0000">'\Foo::test'</span><span style="color: #007700">); </span><span style="color: #FF8000">// A partir de PHP 5.3.0<br /><br /></span><span style="color: #007700">new </span><span style="color: #0000BB">ClaseInexistente</span><span style="color: #007700">;<br /><br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
    </div>

    <div class="example-contents"><p>El resultado del ejemplo
sería algo similar a:</p></div>
    <div class="example-contents screen">
<div class="examplescode"><pre class="examplescode">[[Foobar\ClaseInexistente]]
Fatal error: Class &#039;Foobar\ClaseInexistente&#039; not found in ...</pre>
</div>
    </div>
   </div>
  </p>
 </div>

 
 <div class="refsect1 seealso" id="refsect1-function.spl-autoload-register-seealso">
  <h3 class="title">Ver también</h3>
  <p class="para">
   <ul class="simplelist">
    <li><span class="function"><a href="function.autoload.php" class="function" rel="rdfs-seeAlso">__autoload()</a> - Intenta cargar una clase sin definir</span></li>
   </ul>
  </p>
 </div>

 
</div><?php manual_footer($setup); ?>